use crate::util::pack::{pack_u8, pack_u16};

use super::Packet;

#[derive(Clone)]
pub struct PacketTestResult {
    pub result:bool,
    pub text:String,
}
impl PacketTestResult {
    pub fn new(result:bool, text:&str) -> Self
    {
        Self { result, text:text.to_string() }
    }
}
impl Packet for PacketTestResult {
    type Data = Self;
    
    fn encode(&self) -> Vec<u8>
    {
        let bytes = self.text.as_bytes().to_vec();
        [
            pack_u8(self.result as u8),
            pack_u16(bytes.len() as u16),
            bytes,
        ].concat()
    }
}
